<template>

    <div ref="scrollContainer" class="scroll-container w-100">
        <!-- pull to refresh -->
        <PullToRefresh ref="pullRefresh" :container="scrollContainer" @refresh="fetchData"></PullToRefresh>
        <div class="container mx-auto p-5 mb-12">
            <!-- page title -->
            <PageTitle title="Real-Time Consumptions" />

            <!-- list of devices -->
            <div class="grid gap-5 sm:grid-cols-1 md:grid-cols-1 lg:grid-cols-2">
                <div v-if="list" v-for="item in list">
                    <Line class="p-5 bg-opacity-50 bg-gray-900 rounded-md w-100" :data="getChartData(item)" :options="getChartOption(item)" />
                </div>
                <div v-if="!list">
                    
                </div>
            </div>
            
            <!-- Loading -->
            <div v-if="loading">
                <div class="skeleton h-32 w-full flex flex-col justify-center">
                    <button class="">
                        <span class="loading loading-spinner"></span>
                        Loading Devices Data...
                    </button>
                </div>
            </div>
        </div>
    </div>
</template>
  
<script>
    import PullToRefresh from '@/components/PullToRefresh.vue';
    import PageTitle from '@/components/PageTitle.vue';

    import {
        Chart as ChartJS,
        CategoryScale,
        LinearScale,
        PointElement,
        LineElement,
        Title,
        Tooltip,
        Legend,
TimeScale
    } from 'chart.js'
    import 'chartjs-adapter-moment';
    import { Line } from 'vue-chartjs'
    
    ChartJS.register(
        CategoryScale,
        LinearScale,
        PointElement,
        LineElement,
        Title,
        Tooltip,
        Legend,
        TimeScale
    )

    
    export default {
        components: {
            PullToRefresh,
            PageTitle,
            Line
        },
        data() {
            return {
                list: [], // array of items
                scrollContainer: {}, // useful element for pull-to-refresh
                loading: false,
                socket: null
            }
        },
        mounted() {
            // prepare the pull-to-refresh
            this.scrollContainer = this.$refs.scrollContainer
            this.$refs.pullRefresh.init()
            
            // listen for backend realtime updates
            this.socket = new WebSocket(this.WS_URL);
            this.socket.onopen = () => {
                console.log('WebSocket Client Connected');
            };
            this.socket.onmessage = (msg) => {
                msg = JSON.parse(msg.data);
                if (msg.type === "REGISTERED_CONSUMPTION" /*|| msg.type === "STATUS_UPDATE"*/) {
                    let refDeviceId = msg.device;
                    this.fetchData(refDeviceId)
                }
            };

            // fetch the data for the first time
            this.fetchData(0)
        },
        methods: {
            /**
             * REST API calls
             */
            async fetchData(deviceId) {
                // GET /devices
                var self = this;
                self.loading = true;

                try {
                    const {data} = await self.$axios.get('/stats')
                    self.showError = false
                    if(deviceId == 0){
                        self.list = []
                        self.list = data

                        if(self.socket !== null){
                            self.socket.send(JSON.stringify({
                                devices: self.list.map(dev => dev.id)
                            }));
                        }
                    } else {
                        let index = self.list.findIndex(item => item.id === deviceId)
                        if(index >= 0)
                            self.list[index] = data[data.findIndex(item => item.id === deviceId)]
                    }
                } catch (error) {
                    self.showError = true
                    self.errorText = error.response.data.message
                } finally {
                    setTimeout(() => {
                        this.$refs.pullRefresh.refreshSuccess()
                    }, 2000)
                    self.loading = false;
                    this.$forceUpdate();
                }
            },
            getChartData(deviceItem) {
                let tempDataset = []; 

                deviceItem.logs = deviceItem.logs.sort(function(a,b){
                    return new Date(a.timestamp) - new Date(b.timestamp);
                });

                for(let log of deviceItem.logs) {
                    let logDate = new Date(log.timestamp);
                    let xLabel = `${logDate.getFullYear()}-${logDate.getMonth()+1}-${logDate.getDate()} ${logDate.getHours()}:00:00` // ${logDate.getDate().toString().padStart(2, "0")}/${logDate.getMonth().toString().padStart(2, "0")} @ ${logDate.getHours().toString().padStart(2, "0")}h`
                    let creaChiave = true;
                    for(let tD of tempDataset){
                        if(tD.x == xLabel){
                            creaChiave = false;
                            tD.y = (tD.y*tD.quanti + log.value)/++tD.quanti;
                            break;
                        }
                    }

                    if(creaChiave){
                        tempDataset.push({x: xLabel, y: log.value, quanti: 1})
                    }
                }
                

                tempDataset = tempDataset.sort((a,b) => { return new Date(a.x) - new Date(b.x) });

                const targetColor = '#00d6aa';
                const similarityThreshold = 50;

                // let randomColor = getSimilarColor(targetColor, similarityThreshold);

                return {
                    labels: tempDataset.map(tD => { return tD.x; }),
                    datasets: [
                        {
                            data: tempDataset,
                            label: 'Average Consumption [kWh/%] per Hour',
                            backgroundColor: '#00d6aa',
                            borderColor: '#00d6aa',
                            pointerBackgroundColor: '#00ff00'
                        }
                    ],
                }
            },
            getChartOption(deviceItem){
                const isSmallScreen = window.innerWidth < 450;

                function formatTicks(value) {
                    const absValue = Math.abs(value);
                    if (absValue >= 1000) {
                        // Convert to kilo (k) and format with one decimal place
                        return (value / 1000).toFixed(1) + ' k kWh/%';
                    } else {
                        return value + ' kWh/%';
                    }
                }

                return {
                    layout: {
                        autoPadding: true
                    },
                    responsive: true,
                    maintainAspectRatio: false,
                    aspectRatio: 1,
                    plugins: {
                        title: {
                            display: true,
                            text: deviceItem.name,
                            color: '#FFFFF0',
                            font: {
                                size: isSmallScreen ? 20 : 25,
                            }
                        },
                        legend: {
                            display: true,
                            labels: {
                                color: '#FFFFF0',
                                font: {
                                    size: isSmallScreen ? 13 : 20,
                                }
                            }
                        },
                        colorschemes: {
                            scheme: 'brewer.Paired12'
                        },
                    },
                    scales: {
                        x: {
                            type: 'time',
                            time: {
                                unit: 'hour',
                                displayFormats: {
                                    hour: 'MMM DD HH:mm'
                                }
                            },
                            beginAtZero: true,
                            ticks: {
                                maxTicksLimit: isSmallScreen ? 3 : 8,
                                color: '#FFFFF0',
                                font: {
                                    size: isSmallScreen ? 15 : 20,
                                }
                            },
                            grid: {
                                color: 'rgba(226,223,210, 0.2)',
                            }
                        },
                        y: {
                            beginAtZero: true,
                            ticks: {
                                maxTicksLimit: isSmallScreen ? 3 : 6,
                                color: '#FFFFF0',
                                font: {
                                    size: isSmallScreen ? 14 : 18,
                                },
                                callback: function(value, index, values) {
                                    return formatTicks(value);
                                }
                            },
                            grid: {
                                color: 'rgba(226,223,210, 0.2)'
                            }
                        }
                    }
                }
            }
        }
    };

    function generateColor() {
    return '#' + Math.floor(Math.random() * 16777215).toString(16);
    }

    function hexToRgb(hex) {
        const bigint = parseInt(hex.substring(1), 16);
        const r = (bigint >> 16) & 255;
        const g = (bigint >> 8) & 255;
        const b = bigint & 255;
        return { r, g, b };
    }

    function calculateColorDistance(color1, color2) {
        const diffR = color1.r - color2.r;
        const diffG = color1.g - color2.g;
        const diffB = color1.b - color2.b;
        return Math.sqrt(diffR * diffR + diffG * diffG + diffB * diffB);
    }

    function getSimilarColor(targetColor, similarityThreshold) {
        const targetRgb = hexToRgb(targetColor);

        while (true) {
            const generatedColor = generateColor();
            const generatedRgb = hexToRgb(generatedColor);
            const distance = calculateColorDistance(targetRgb, generatedRgb);

            if (distance <= similarityThreshold) {
                return generatedColor;
            }
        }
    }
</script>